// Licensed Materials - Property of IBM
// (C) Copyright IBM Corp. 2004, 2004.  All Rights Reserved.
//
// US Government Users Restricted Rights - Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.
//

#include "StdAfx.h"
#include "CReqProGUIAppWrapper.h"

CReqProGUIAppWrapper::CReqProGUIAppWrapper()
{
}

CReqProGUIAppWrapper::~CReqProGUIAppWrapper()
{
}

STDMETHODIMP CReqProGUIAppWrapper::SetGUIApp(long cppPtr)
{
    m_rqguiapp = (IDispatch*)cppPtr;
    return S_OK;
}

STDMETHODIMP CReqProGUIAppWrapper::CreateGUIApp()
{
    return m_rqguiapp.CreateInstance("ReqPro40.GUIApp");
}


// IReqProGUIAppWrapper methods

STDMETHODIMP CReqProGUIAppWrapper::SelectExplorerKey(long type, long elementKey, VARIANT_BOOL* result)
{
    if (result == 0) {
        return E_INVALIDARG;
    }
    return m_rqguiapp->raw_SelectExplorerKey(type, elementKey, result);
}

STDMETHODIMP CReqProGUIAppWrapper::RefreshRequirement(long elementKey, VARIANT_BOOL* result)
{
    if (result == 0) {
        return E_INVALIDARG;
    }
    return m_rqguiapp->raw_RefreshRequirement(elementKey, result);
}

STDMETHODIMP CReqProGUIAppWrapper::RefreshExplorer(VARIANT_BOOL* result)
{
    if (result == 0) {
        return E_INVALIDARG;
    }
    return m_rqguiapp->raw_RefreshExplorer(result);
}

STDMETHODIMP CReqProGUIAppWrapper::ShowWord(VARIANT_BOOL* result)
{
    if (result == 0) {
        return E_INVALIDARG;
    }
    return m_rqguiapp->raw_ShowWord(result);
}

STDMETHODIMP CReqProGUIAppWrapper::CurrentProjectPath(BSTR* result)
{
    if (result == 0) {
        return E_INVALIDARG;
    }
    return m_rqguiapp->raw_CurrentProjectPath(result);
}

STDMETHODIMP CReqProGUIAppWrapper::Name(BSTR* result)
{
    if (result == 0) {
        return E_INVALIDARG;
    }
    return m_rqguiapp->raw_Name(result);
}

STDMETHODIMP CReqProGUIAppWrapper::OpenProject(BSTR projectPath, long optionType, BSTR userID, BSTR pwd, long projectFlags, IDispatch** callback, VARIANT_BOOL* result)
{
    if (callback == 0) {
        return E_INVALIDARG;
    }
    if (result == 0) {
        return E_INVALIDARG;
    }
    return m_rqguiapp->raw_OpenProject(projectPath, optionType, userID, pwd, projectFlags, callback, result);
}

STDMETHODIMP CReqProGUIAppWrapper::CloseProject(IDispatch** project, VARIANT_BOOL confirm, IDispatch** callback, VARIANT_BOOL* result)
{
    if (project == 0) {
        return E_INVALIDARG;
    }
    if (callback == 0) {
        return E_INVALIDARG;
    }
    if (result == 0) {
        return E_INVALIDARG;
    }
    return m_rqguiapp->raw_CloseProject(project, confirm, callback, result);
}

STDMETHODIMP CReqProGUIAppWrapper::ShowToolPalette(VARIANT_BOOL* result)
{
    if (result == 0) {
        return E_INVALIDARG;
    }
    return m_rqguiapp->raw_ShowToolPalette(result);
}

STDMETHODIMP CReqProGUIAppWrapper::IsOpen(IDispatch** doc, IDispatch** callback, VARIANT_BOOL* result)
{
    if (doc == 0) {
        return E_INVALIDARG;
    }
    if (callback == 0) {
        return E_INVALIDARG;
    }
    if (result == 0) {
        return E_INVALIDARG;
    }
    return m_rqguiapp->raw_IsOpen(doc, callback, result);
}

STDMETHODIMP CReqProGUIAppWrapper::PositionDocument(IDispatch** document, BSTR positionId, long positionInteger, IDispatch** callback, VARIANT_BOOL* result)
{
    if (document == 0) {
        return E_INVALIDARG;
    }
    if (callback == 0) {
        return E_INVALIDARG;
    }
    if (result == 0) {
        return E_INVALIDARG;
    }
    return m_rqguiapp->raw_PositionDocument(document, positionId, positionInteger, callback, result);
}

STDMETHODIMP CReqProGUIAppWrapper::OpenDocument(IDispatch** document, long flag, VARIANT_BOOL prompt, IDispatch** callback, VARIANT_BOOL* result)
{
    if (document == 0) {
        return E_INVALIDARG;
    }
    if (callback == 0) {
        return E_INVALIDARG;
    }
    if (result == 0) {
        return E_INVALIDARG;
    }
    return m_rqguiapp->raw_OpenDocument(document, flag, prompt, callback, result); 

}

STDMETHODIMP CReqProGUIAppWrapper::CloseDocument(IDispatch** document, VARIANT_BOOL save, IDispatch** callback, VARIANT_BOOL* result)
{
    if (document == 0) {
        return E_INVALIDARG;
    }
    if (callback == 0) {
        return E_INVALIDARG;
    }
    if (result == 0) {
        return E_INVALIDARG;
    }
    return m_rqguiapp->raw_CloseDocument(document, save, callback, result);
}
