// Licensed Materials - Property of IBM
// (C) Copyright IBM Corp. 2001, 2004.  All Rights Reserved.
//
// US Government Users Restricted Rights - Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.
//

package com.ibm.xtools.reqpro.RqCallback;

public interface _Callback {

    public static final String IID = "00020400-0000-0000-C000-000000000046";
    public static final Class BRIDGECLASS = RqCallbackBridgeObjectProxy.class;

    /** 
     * SetDone. Called by RequisitePro when the operation is complete.
     */
    public void SetDone(boolean bDone) throws java.io.IOException;

    /** 
     * SetProjectOpened. Called by RequisitePro when the OpenProject operation is complete.
     */
    public void SetProjectOpened(boolean bDone) throws java.io.IOException;

    /** 
     * SetReturnInformation. Called by RequisitePro when the operation needs to returns an object reference.
     */
    public void SetReturnInformation(boolean bSuccess, Object vObject, String sErrorString) throws java.io.IOException;

    /** 
     * SetErrorInformation. Called by RequisitePro when the operation encounters an error.
     */
    public void SetErrorInformation(String sErrorString) throws java.io.IOException;

    /** 
     * IsDone. Returns whether or not the operation is finished.
     */
    public boolean IsDone() throws java.io.IOException;

    /** 
     * HasSuccess. Returns whether or not the operation completed successfully.
     */
    public boolean HasSuccess() throws java.io.IOException;

    /** 
     * GetObject. Returns the requested object or value (such as, a project or document).
     */
    public Object GetObject() throws java.io.IOException;

    /** 
     * GetError. Returns the error reported by the operation.
     */
    public String GetError() throws java.io.IOException;

}
